/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.27 Revision 1.40
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.27 2005/07/06 20:20:03 agriffis Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.40 2006/02/16 21:46:50 exg Exp $
4# 4#
5# Description: This eclass is used as a central eclass for accessing kernel 5# Description: This eclass is used as a central eclass for accessing kernel
6# related information for sources already installed. 6# related information for sources already installed.
7# It is vital for linux-mod to function correctly, and is split 7# It is vital for linux-mod to function correctly, and is split
8# out so that any ebuild behaviour "templates" are abstracted out 8# out so that any ebuild behaviour "templates" are abstracted out
13# 13#
14# Please direct your bugs to the current eclass maintainer :) 14# Please direct your bugs to the current eclass maintainer :)
15 15
16# A Couple of env vars are available to effect usage of this eclass 16# A Couple of env vars are available to effect usage of this eclass
17# These are as follows: 17# These are as follows:
18# 18#
19# Env Var Option Description 19# Env Var Option Description
20# KERNEL_DIR <string> The directory containing kernel the target kernel 20# KERNEL_DIR <string> The directory containing kernel the target kernel
21# sources. 21# sources.
22# CONFIG_CHECK <string> a list of .config options to check for before 22# CONFIG_CHECK <string> a list of .config options to check for before
23# proceeding with the install. ie: CONFIG_CHECK="MTRR" 23# proceeding with the install. ie: CONFIG_CHECK="MTRR"
24# You can also check that an option doesn't exist by 24# You can also check that an option doesn't exist by
25# prepending it with an exclamation mark (!). 25# prepending it with an exclamation mark (!).
26# ie: CONFIG_CHECK="!MTRR" 26# ie: CONFIG_CHECK="!MTRR"
27# To simply warn about a missing option, prepend a '~'.
27# ERROR_CFG <string> The error message to display when the above check 28# ERROR_CFG <string> The error message to display when the above check
28# fails. <CFG> should reference the appropriate option 29# fails. <CFG> should reference the appropriate option
29# as above. ie: ERROR_MTRR="MTRR exists in the .config 30# as above. ie: ERROR_MTRR="MTRR exists in the .config
30# but shouldn't!!" 31# but shouldn't!!"
31# KBUILD_OUTPUT <string> This is passed on commandline, or can be set from 32# KBUILD_OUTPUT <string> This is passed on commandline, or can be set from
32# the kernel makefile. This contains the directory 33# the kernel makefile. This contains the directory
33# which is to be used as the kernel object directory. 34# which is to be used as the kernel object directory.
34 35
35# There are also a couple of variables which are set by this, and shouldn't be 36# There are also a couple of variables which are set by this, and shouldn't be
36# set by hand. These are as follows: 37# set by hand. These are as follows:
37# 38#
38# Env Var Option Description 39# Env Var Option Description
39# KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1 40# KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1
40# KV_MAJOR <integer> The kernel major version. ie: 2 41# KV_MAJOR <integer> The kernel major version. ie: 2
41# KV_MINOR <integer> The kernel minor version. ie: 6 42# KV_MINOR <integer> The kernel minor version. ie: 6
42# KV_PATCH <integer> The kernel patch version. ie: 9 43# KV_PATCH <integer> The kernel patch version. ie: 9
49# .config. 50# .config.
50 51
51# And to ensure all the weirdness with crosscompile 52# And to ensure all the weirdness with crosscompile
52inherit toolchain-funcs versionator 53inherit toolchain-funcs versionator
53 54
54INHERITED="$INHERITED $ECLASS"
55EXPORT_FUNCTIONS pkg_setup 55EXPORT_FUNCTIONS pkg_setup
56
57DEPEND="kernel_linux? ( virtual/linux-sources )"
58RDEPEND=""
56 59
57# Overwritable environment Var's 60# Overwritable environment Var's
58# --------------------------------------- 61# ---------------------------------------
59KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}" 62KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
60 63
61 64
62# Bug fixes 65# Bug fixes
63# fix to bug #75034 66# fix to bug #75034
64case ${ARCH} in 67case ${ARCH} in
65 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";; 68 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
66 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";; 69 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
67esac 70esac
68 71
69# These are legacy wrappers for toolchain-funcs. 72# These are legacy wrappers for toolchain-funcs.
70# I dont like them here, but oh well. 73# I dont like them here, but oh well.
71set_arch_to_kernel() { export ARCH="$(tc-arch-kernel)"; } 74set_arch_to_kernel() { export ARCH="$(tc-arch-kernel)"; }
108 then 111 then
109 echo -e "\n" 112 echo -e "\n"
110 eerror "getfilevar requires 2 variables, with the second a valid file." 113 eerror "getfilevar requires 2 variables, with the second a valid file."
111 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 114 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
112 else 115 else
113 workingdir=${PWD} 116 workingdir="${PWD}"
114 basefname=$(basename ${2}) 117 basefname="$(basename ${2})"
115 basedname=$(dirname ${2}) 118 basedname="$(dirname ${2})"
116 unset ARCH 119 unset ARCH
117 120
118 cd ${basedname} 121 cd "${basedname}"
119 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \ 122 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
120 make ${BUILD_FIXES} -s -f - e 2>/dev/null 123 make ${BUILD_FIXES} -s -f - e 2>/dev/null
121 cd ${workingdir} 124 cd "${workingdir}"
122 125
123 ARCH=${myARCH} 126 ARCH=${myARCH}
124 fi 127 fi
125} 128}
126 129
188 test="${test}${KV_PATCH}";; 191 test="${test}${KV_PATCH}";;
189 *) die "Error in kernel-2_kernel_is(): Too many parameters.";; 192 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
190 esac 193 esac
191 done 194 done
192 195
193 [ ${test} ${operator} ${value} ] && return 0 || return 1 196 [ ${test} ${operator} ${value} ] && return 0 || return 1
197}
198
199get_localversion() {
200 local lv_list i x
201
202 # ignore files with ~ in it.
203 for i in $(ls ${1}/localversion* 2>/dev/null); do
204 [[ -n ${i//*~*} ]] && lv_list="${lv_list} ${i}"
205 done
206
207 for i in ${lv_list}; do
208 x="${x}$(<${i})"
209 done
210 x=${x/ /}
211 echo ${x}
194} 212}
195 213
196get_version() { 214get_version() {
197 local kbuild_output 215 local kbuild_output
198 216
199 # no need to execute this twice assuming KV_FULL is populated. 217 # no need to execute this twice assuming KV_FULL is populated.
200 # we can force by unsetting KV_FULL 218 # we can force by unsetting KV_FULL
201 [ -n "${KV_FULL}" ] && return 0 219 [ -n "${KV_FULL}" ] && return 0
202 220
203 # if we dont know KV_FULL, then we need too. 221 # if we dont know KV_FULL, then we need too.
206 224
207 # KV_DIR will contain the full path to the sources directory we should use 225 # KV_DIR will contain the full path to the sources directory we should use
208 qeinfo "Determining the location of the kernel source code" 226 qeinfo "Determining the location of the kernel source code"
209 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 227 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
210 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 228 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
211 229
212 if [ -z "${KV_DIR}" ] 230 if [ -z "${KV_DIR}" ]
213 then 231 then
214 qeerror "Unable to find kernel sources at ${KERNEL_DIR}" 232 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
215 qeinfo "This package requires Linux sources." 233 qeinfo "This package requires Linux sources."
216 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then 234 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
230 then 248 then
231 qeerror "Could not find a Makefile in the kernel source directory." 249 qeerror "Could not find a Makefile in the kernel source directory."
232 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources" 250 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
233 return 1 251 return 1
234 fi 252 fi
235 253
236 # OK so now we know our sources directory, but they might be using 254 # OK so now we know our sources directory, but they might be using
237 # KBUILD_OUTPUT, and we need this for .config and localversions-* 255 # KBUILD_OUTPUT, and we need this for .config and localversions-*
238 # so we better find it eh? 256 # so we better find it eh?
239 # do we pass KBUILD_OUTPUT on the CLI? 257 # do we pass KBUILD_OUTPUT on the CLI?
240 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}" 258 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
241 259
242 # And if we didn't pass it, we can take a nosey in the Makefile 260 # And if we didn't pass it, we can take a nosey in the Makefile
243 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)" 261 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)"
244 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}" 262 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
245 263
246 # And contrary to existing functions I feel we shouldn't trust the 264 # And contrary to existing functions I feel we shouldn't trust the
247 # directory name to find version information as this seems insane. 265 # directory name to find version information as this seems insane.
248 # so we parse ${KV_DIR}/Makefile 266 # so we parse ${KV_DIR}/Makefile
249 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 267 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)"
250 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 268 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)"
251 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 269 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)"
252 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 270 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)"
253 271
254 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ] 272 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
255 then 273 then
256 qeerror "Could not detect kernel version." 274 qeerror "Could not detect kernel version."
257 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources." 275 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
258 return 1 276 return 1
259 fi 277 fi
260 278
261 # and in newer versions we can also pull LOCALVERSION if it is set. 279 # and in newer versions we can also pull LOCALVERSION if it is set.
262 # but before we do this, we need to find if we use a different object directory. 280 # but before we do this, we need to find if we use a different object directory.
263 # This *WILL* break if the user is using localversions, but we assume it was 281 # This *WILL* break if the user is using localversions, but we assume it was
264 # caught before this if they are. 282 # caught before this if they are.
265 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \ 283 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \
269 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}" 287 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
270 if [ -n "${KV_OUT_DIR}" ]; 288 if [ -n "${KV_OUT_DIR}" ];
271 then 289 then
272 qeinfo "Found kernel object directory:" 290 qeinfo "Found kernel object directory:"
273 qeinfo " ${KV_OUT_DIR}" 291 qeinfo " ${KV_OUT_DIR}"
274 292
275 KV_LOCAL="$(cat ${KV_OUT_DIR}/localversion* 2>/dev/null)" 293 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
276 fi 294 fi
277 # and if we STILL haven't got it, then we better just set it to KV_DIR 295 # and if we STILL haven't got it, then we better just set it to KV_DIR
278 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}" 296 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
279 297
280 KV_LOCAL="${KV_LOCAL}$(cat ${KV_DIR}/localversion* 2>/dev/null)" 298 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})"
281 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)" 299 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
282 KV_LOCAL="${KV_LOCAL//\"/}" 300 KV_LOCAL="${KV_LOCAL//\"/}"
283 301
284 # And we should set KV_FULL to the full expanded version 302 # And we should set KV_FULL to the full expanded version
285 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 303 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
328# --------------------------------------- 346# ---------------------------------------
329 347
330check_kernel_built() { 348check_kernel_built() {
331 # if we haven't determined the version yet, we need too. 349 # if we haven't determined the version yet, we need too.
332 get_version; 350 get_version;
333 351
334 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ] 352 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
335 then 353 then
336 eerror "These sources have not yet been prepared." 354 eerror "These sources have not yet been prepared."
337 eerror "We cannot build against an unprepared tree." 355 eerror "We cannot build against an unprepared tree."
338 eerror "To resolve this, please type the following:" 356 eerror "To resolve this, please type the following:"
347} 365}
348 366
349check_modules_supported() { 367check_modules_supported() {
350 # if we haven't determined the version yet, we need too. 368 # if we haven't determined the version yet, we need too.
351 get_version; 369 get_version;
352 370
353 if ! linux_chkconfig_builtin "MODULES" 371 if ! linux_chkconfig_builtin "MODULES"
354 then 372 then
355 eerror "These sources do not support loading external modules." 373 eerror "These sources do not support loading external modules."
356 eerror "to be able to use this module please enable \"Loadable modules support\"" 374 eerror "to be able to use this module please enable \"Loadable modules support\""
357 eerror "in your kernel, recompile and then try merging this module again." 375 eerror "in your kernel, recompile and then try merging this module again."
358 die "No support for external modules in ${KV_FULL} config" 376 die "No support for external modules in ${KV_FULL} config"
359 fi 377 fi
360} 378}
361 379
362check_extra_config() { 380check_extra_config() {
363 local config negate error local_error i n temp_config 381 local config negate error local_error i n
382 local temp_config die reworkmodulenames
364 383
365 # if we haven't determined the version yet, we need too. 384 # if we haven't determined the version yet, we need too.
366 get_version; 385 get_version;
367 386
368 einfo "Checking for suitable kernel configuration options" 387 einfo "Checking for suitable kernel configuration options:"
369 for config in ${CONFIG_CHECK} 388 for config in ${CONFIG_CHECK}
370 do 389 do
371 negate="${config:0:1}" 390 # if we specify any fatal, ensure we honor them
372 if [ "${negate}" == "!" ]; 391 die=1
373 then 392 error=0
393 negate=0
394 reworkmodulenames=0
395
396 if [[ -z ${config//\!*} ]]; then
397 negate=1
374 config="${config:1}" 398 config=${config:1}
375 if linux_chkconfig_present ${config}
376 then
377 local_error="${config}_ERROR"
378 local_error="${!local_error}"
379 [ -n "${local_error}" ] && eerror " ${local_error}" || \
380 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
381 error=1
382 fi 399 fi
383 elif [ "${negate}" == "@" ]; 400 if [[ -z ${config/\@*} ]]; then
384 then 401 die=2
385 # we never call this unless we are using MODULE_NAMES 402 reworkmodulenames=1
386
387 config="${config:1}" 403 config=${config:1}
404 fi
405 if [[ -z ${config/\~*} ]]; then
406 die=0
407 config=${config:1}
408 fi
409
410 if [[ ${negate} == 1 ]]; then
411 linux_chkconfig_present ${config} && error=2
412 elif [[ ${reworkmodulenames} == 1 ]]; then
388 temp_config="${config//*:}" 413 temp_config="${config//*:}"
389 config="${config//:*}" 414 config="${config//:*}"
390 if linux_chkconfig_present ${config} 415 if linux_chkconfig_present ${config}; then
391 then
392 local_error="${config}_ERROR"
393 local_error="${!local_error}"
394 [ -n "${local_error}" ] && eerror " ${local_error}" || \
395 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
396
397 for i in ${MODULE_NAMES} 416 for i in ${MODULE_NAMES}; do
398 do
399 n="${i//${temp_config}}" 417 n="${i//${temp_config}}"
418 [[ -z ${n//\(*} ]] && \
400 [ -z "${n//(*}" ] && MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}" 419 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
401 done 420 done
402 error=0 421 error=2
403 fi 422 fi
404 else 423 else
405 if ! linux_chkconfig_present ${config} 424 linux_chkconfig_present ${config} || error=1
406 then 425 fi
407 # Support the new syntax first. 426
427 if [[ ${die} == 0 ]]; then
428 ebegin "CONFIG_${config}"
429 eend ${error}
430 else
431 if [[ ${error} > 0 ]]; then
408 local_error="ERROR_${config}" 432 local_error="ERROR_${config}"
409 local_error="${!local_error}" 433 local_error="${!local_error}"
410 434
411 # then fall back on the older syntax.
412 if [[ -z ${local_error} ]] ; then 435 if [[ -z "${local_error}" ]]; then
436 # using old, deprecated format.
413 local_error="${config}_ERROR" 437 local_error="${config}_ERROR"
414 local_error="${!local_error}" 438 local_error="${!local_error}"
415 fi 439 fi
440
441 if [[ -z "${local_error}" ]]; then
442 [[ ${error} == 1 ]] \
443 && local_error="is not set when it should be." \
444 || local_error="should not be set. But it is."
445 local_error="CONFIG_${config}:\t ${local_error}"
416 446 fi
417 [[ -n ${local_error} ]] && eerror " ${local_error}" || \ 447 eerror " ${local_error}"
418 eerror " CONFIG_${config}:\tshould be set in the kernel configuration, but isn't"
419 error=1
420 fi 448 fi
421 fi 449 fi
422 done 450 done
423 451
424 if [ "${error}" == 1 ] ; 452 if [[ ${error} > 0 ]]; then
425 then
426 eerror "Please check to make sure these options are set correctly." 453 eerror "Please check to make sure these options are set correctly."
454 eerror "Failure to do so may cause unexpected problems."
455 if [[ ${die} == 1 ]]; then
427 eerror "Once you have satisfied these options, please try merging" 456 eerror "Once you have satisfied these options, please try merging"
428 eerror "this package again." 457 eerror "this package again."
429 die "Incorrect kernel configuration options" 458 die "Incorrect kernel configuration options"
459 fi
430 fi 460 fi
431} 461}
432 462
433check_zlibinflate() { 463check_zlibinflate() {
434 # if we haven't determined the version yet, we need too. 464 # if we haven't determined the version yet, we need too.
435 get_version; 465 get_version;
436 466
437 # although I restructured this code - I really really really dont support it! 467 # although I restructured this code - I really really really dont support it!
438 468
439 # bug #27882 - zlib routines are only linked into the kernel 469 # bug #27882 - zlib routines are only linked into the kernel
440 # if something compiled into the kernel calls them 470 # if something compiled into the kernel calls them
441 # 471 #
442 # plus, for the cloop module, it appears that there's no way 472 # plus, for the cloop module, it appears that there's no way
443 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS 473 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS
444 # is on 474 # is on
445 475
446local INFLATE 476 local INFLATE
447local DEFLATE 477 local DEFLATE
448 478
449 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 479 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
450 480
451 ebegin "checking ZLIB_INFLATE" 481 ebegin "checking ZLIB_INFLATE"
452 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 482 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config
453 eend $? 483 eend $?
454 [ "$?" != 0 ] && die 484 [ "$?" != 0 ] && die
455 485
456 ebegin "checking ZLIB_DEFLATE" 486 ebegin "checking ZLIB_DEFLATE"
457 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 487 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config
458 eend $? 488 eend $?
459 [ "$?" != 0 ] && die 489 [ "$?" != 0 ] && die
460 490
461
462 local LINENO_START 491 local LINENO_START
463 local LINENO_END 492 local LINENO_END
464 local SYMBOLS 493 local SYMBOLS
465 local x 494 local x
466 495
467 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)" 496 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
468 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)" 497 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
469 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START )) 498 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
470 (( LINENO_END = $LINENO_END - 1 )) 499 (( LINENO_END = $LINENO_END - 1 ))
471 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')" 500 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
477 # we have a winner! 506 # we have a winner!
478 einfo "${x} ensures zlib is linked into your kernel - excellent" 507 einfo "${x} ensures zlib is linked into your kernel - excellent"
479 return 0 508 return 0
480 fi 509 fi
481 done 510 done
482 511
483 eerror 512 eerror
484 eerror "This kernel module requires ZLIB library support." 513 eerror "This kernel module requires ZLIB library support."
485 eerror "You have enabled zlib support in your kernel, but haven't enabled" 514 eerror "You have enabled zlib support in your kernel, but haven't enabled"
486 eerror "enabled any option that will ensure that zlib is linked into your" 515 eerror "enabled any option that will ensure that zlib is linked into your"
487 eerror "kernel." 516 eerror "kernel."

Legend:
Removed from v.1.27  
changed lines
  Added in v.1.40

  ViewVC Help
Powered by ViewVC 1.1.20